/// Version string shown in settings page
const versionStr = "48.0";
const version = 480;

/// Show a snack bar for a short amount of time
const snackBarDurationShort = Duration(seconds: 4);

/// Show a snack bar for a normal amount of time
const snackBarDurationNormal = Duration(seconds: 7);

/// Duration for short animation
const animationDurationShort = Duration(milliseconds: 100);

/// Duration for normal animation
const animationDurationNormal = Duration(milliseconds: 250);

/// Duration for long animation
const animationDurationLong = Duration(milliseconds: 500);

/// Duration for tab transition animation
const animationDurationTabTransition = Duration(milliseconds: 400);

/// Size of the photo/video thumbnails
///
/// It's advisable to use a single size to minimize cache size
const photoThumbSize = 256;

/// Size of the face thumbnails
const faceThumbSize = 192;

/// Size of the opened photos
const photoLargeSize = 1080;

/// Size of the cover photos
const coverSize = 512;

/// AppDb lock ID
const appDbLockId = 1;
